package com.docus.sw.fenpan;

import com.docus.sw.Config;
import com.docus.sw.souyin.CheckService;
import com.docus.sw.souyin.SuoyinService;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

public class MyApplication {
    public static void main(String[] args) throws IOException {
        Config.loadConfig();
        // 获取系统支持的外观信息
//        UIManager.LookAndFeelInfo[] lookAndFeels = UIManager.getInstalledLookAndFeels();
//
//        // 遍历可用的外观并设置所选外观
//        for (UIManager.LookAndFeelInfo info : lookAndFeels) {
//            if ("Nimbus".equals(info.getName())) { // 选择Nimbus外观
//                try {
//                    UIManager.setLookAndFeel(info.getClassName());
//                    break;
//                } catch (Exception e) {
//                    e.printStackTrace();
//                }
//            }
//        }

        try {
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        } catch (InstantiationException e) {
            throw new RuntimeException(e);
        } catch (IllegalAccessException e) {
            throw new RuntimeException(e);
        } catch (UnsupportedLookAndFeelException e) {
            throw new RuntimeException(e);
        }

        SwingUtilities.invokeLater(() -> createAndShowGUI());
    }

    private static void createAndShowGUI() {
        JFrame frame = new JFrame("数转模前处理软件 V2.1");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(600, 400);

        JTabbedPane tabbedPane = new JTabbedPane();

        // 参数设置标签页
        JPanel paramPanel = new JPanel(new GridBagLayout());
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.insets = new Insets(5, 5, 5, 5);

        JPanel sizePanel3 = new JPanel(new FlowLayout(FlowLayout.LEFT));
        sizePanel3.add(new JLabel("A0大小尺寸(英寸) 长:"));
        JTextField a0LongJtf = new JTextField(5);
        sizePanel3.add(a0LongJtf);
        sizePanel3.add(new JLabel("宽:"));
        JTextField a0WidthJt = new JTextField(5);
        sizePanel3.add(a0WidthJt);

        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.gridwidth = 2;
        gbc.anchor = GridBagConstraints.WEST;
        paramPanel.add(sizePanel3, gbc);

        JPanel sizePanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        sizePanel.add(new JLabel("A4大小尺寸(英寸) 长:"));
        JTextField a4LongJtf = new JTextField(5);
        sizePanel.add(a4LongJtf);
        sizePanel.add(new JLabel("宽:"));
        JTextField a4WidthJtf = new JTextField(5);
        sizePanel.add(a4WidthJtf);


        JPanel sizePanel2 = new JPanel(new FlowLayout(FlowLayout.LEFT));
        sizePanel2.add(new JLabel("A3大小尺寸(英寸) 长:"));
        JTextField a3LongJtf2 = new JTextField(5);
        sizePanel2.add(a3LongJtf2);
        sizePanel2.add(new JLabel("宽:"));
        JTextField a3WidthJtf2 = new JTextField(5);
        sizePanel2.add(a3WidthJtf2);

        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.gridwidth = 2;
        gbc.anchor = GridBagConstraints.WEST;
        paramPanel.add(sizePanel, gbc);


        gbc.gridx = 0;
        gbc.gridy = 2;
        gbc.gridwidth = 2;
        gbc.anchor = GridBagConstraints.WEST;
        paramPanel.add(sizePanel2, gbc);

        gbc.gridx = 0;
        gbc.gridy = 3;
        gbc.gridwidth = 1;
        gbc.anchor = GridBagConstraints.WEST;
        paramPanel.add(new JLabel("16mm规格画幅数量（A4合计）:"), gbc);
        gbc.gridx = 1;
        gbc.anchor = GridBagConstraints.CENTER;
        JTextField plateSizeJtf = new JTextField(20);
        paramPanel.add(plateSizeJtf, gbc);


        gbc.gridx = 0;
        gbc.gridy = 4;
        gbc.gridwidth = 1;
        gbc.anchor = GridBagConstraints.WEST;
        paramPanel.add(new JLabel("35mm规格画幅数量:"), gbc);
        gbc.gridx = 1;
        gbc.anchor = GridBagConstraints.CENTER;
        JTextField plateSizeJtf33 = new JTextField(20);
        paramPanel.add(plateSizeJtf33, gbc);



        gbc.gridx = 0;
        gbc.gridy = 5;
        gbc.gridwidth = 2;
        gbc.anchor = GridBagConstraints.CENTER;
        JButton jButton = new JButton("保存设置");
        paramPanel.add(jButton, gbc);


        //添加事件
        jButton.addActionListener(e -> {
            //宗名

            //a3 图片大小
            System.out.println(a4LongJtf.getText());
            System.out.println(a4WidthJtf.getText());

            //盘大小
            String text = plateSizeJtf.getText();
            System.out.println(text);


            Map<String,String> keyvalue = new HashMap<>();
            keyvalue.put("a0.length",a0LongJtf.getText());
            keyvalue.put("a3.length",a3LongJtf2.getText());
            keyvalue.put("a4.length",a4LongJtf.getText());
            keyvalue.put("a0.width",a0WidthJt.getText());
            keyvalue.put("a3.width",a3WidthJtf2.getText());
            keyvalue.put("a4.width",a4WidthJtf.getText());
            keyvalue.put("plate.size",plateSizeJtf.getText());
            keyvalue.put("plate33.size",plateSizeJtf33.getText());
            try {
                Config.updateConfig(keyvalue);
            } catch (IOException ex) {
                throw new RuntimeException(ex);
            }
        });

        // 分盘工具标签页
        JPanel splitPanel = new JPanel(new BorderLayout());
        JPanel leftPanel = new JPanel(new GridBagLayout());
        GridBagConstraints leftGbc = new GridBagConstraints();
        leftGbc.insets = new Insets(5, 5, 5, 5);


        leftGbc.gridx = 0;
        leftGbc.gridy = 0;
        leftPanel.add(new JLabel("规格选择:"));
        String[] rollmodes = {"16mm规格", "35mm规格"};
        JComboBox<String> rollmodeComboBox = new JComboBox<>(rollmodes);
        leftGbc.gridx = 1;
        leftGbc.gridwidth = 1;
        leftPanel.add(rollmodeComboBox);

        leftGbc.gridx = 0;
        leftGbc.gridy = 1;
        leftPanel.add(new JLabel("分盘目录:"), leftGbc);
        JTextField folderField = new JTextField(20);
        leftGbc.gridx = 1;
        leftGbc.gridwidth = 1;
        leftPanel.add(folderField, leftGbc);

        JButton folderChooserButton = new JButton("选择目录");
        folderChooserButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JFileChooser fileChooser = new JFileChooser();
                fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                int returnValue = fileChooser.showOpenDialog(null);
                if (returnValue == JFileChooser.APPROVE_OPTION) {
                    File selectedFile = fileChooser.getSelectedFile();
                    folderField.setText(selectedFile.getAbsolutePath());
                }
            }
        });

        leftGbc.gridx = 2;
        leftPanel.add(folderChooserButton, leftGbc);

        leftGbc.gridx = 0;
        leftGbc.gridy = 2;
        leftPanel.add(new JLabel("保存路径:"), leftGbc);
        JTextField savePathField = new JTextField(20);
        leftGbc.gridx = 1;
        leftPanel.add(savePathField, leftGbc);





        JButton savePathChooserButton = new JButton("选择目录");
        savePathChooserButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JFileChooser fileChooser = new JFileChooser();
                fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                int returnValue = fileChooser.showOpenDialog(null);
                if (returnValue == JFileChooser.APPROVE_OPTION) {
                    File selectedFile = fileChooser.getSelectedFile();
                    savePathField.setText(selectedFile.getAbsolutePath()+"/");
                }
            }
        });

        leftGbc.gridx = 2;
        leftPanel.add(savePathChooserButton, leftGbc);

        leftGbc.gridx = 0;
        leftGbc.gridy = 3;
        leftPanel.add(new JLabel("宗前缀名:"), leftGbc);
        JTextField zongFiled = new JTextField(20);
        leftGbc.gridx = 1;
        leftPanel.add(zongFiled, leftGbc);


        leftGbc.gridx = 0;
        leftGbc.gridy = 4;
        leftPanel.add(new JLabel("起始分盘号:"), leftGbc);
        JTextField spiltNum = new JTextField(20);
        leftGbc.gridx = 1;
        leftPanel.add(spiltNum, leftGbc);



        leftGbc.gridx = 0;
        leftGbc.gridy = 5;
        leftGbc.gridwidth = 2;
        leftGbc.anchor = GridBagConstraints.CENTER;
        JButton fenpanJbtn = new JButton("开始分盘");



        leftPanel.add(fenpanJbtn, leftGbc);

        JTextArea logTextArea = new JTextArea();
        JScrollPane logScrollPane = new JScrollPane(logTextArea);
        logScrollPane.setPreferredSize(new Dimension(200, 200));
        JPanel rightPanel = new JPanel(new BorderLayout());
        rightPanel.add(logScrollPane, BorderLayout.CENTER);


        fenpanJbtn.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                // 在EDT上执行更新操作
                SwingUtilities.invokeLater(new Runnable() {
                    @Override
                    public void run() {

                        logTextArea.append(df.format(new Date())+": 开始分盘。。。"+ "\n");
                        logTextArea.append(df.format(new Date())+": 分盘中。。。"+ "\n");
                    }
                });
                // 启动一个异步任务

                Thread workerThread = new Thread(() -> {
                    // 执行长时间运行的业务操作

                    // 模拟耗时操作
                    String saveUrl = savePathField.getText()+"/";
                    String readUrl = folderField.getText();
                    String s = Objects.requireNonNull(rollmodeComboBox.getSelectedItem()).toString();
                    System.out.println(s);
                    new FenpanService(s,zongFiled.getText(),Integer.parseInt(spiltNum.getText())).fenpan(saveUrl,readUrl);

                    SwingUtilities.invokeLater(new Runnable() {
                        @Override
                        public void run() {
                            // 在EDT上更新UI
                            logTextArea.append(df.format(new Date())+": 分盘结束。。。"+ "\n");
                        }
                    });
                });

                workerThread.start(); // 启动线程

            }
        });


        splitPanel.add(leftPanel, BorderLayout.WEST);
        splitPanel.add(rightPanel, BorderLayout.CENTER);




        tabbedPane.addTab("参数设置", paramPanel);
        tabbedPane.addTab("分盘工具", splitPanel);
        tabbedPane.addTab("检查工具", checkPanel());
        tabbedPane.addTab("索引工具", createIndexPanel());

        frame.add(tabbedPane);
        frame.setVisible(true);


        //加载数据
        a4LongJtf.setText(Config.getParam("a4.length"));
        a0LongJtf.setText(Config.getParam("a0.length"));
        a3LongJtf2.setText(Config.getParam("a3.length"));
        a4WidthJtf.setText(Config.getParam("a4.width"));
        a0WidthJt.setText(Config.getParam("a0.width"));
        a3WidthJtf2.setText(Config.getParam("a3.width"));
        plateSizeJtf.setText(Config.getParam("plate.size"));
        plateSizeJtf33.setText(Config.getParam("plate33.size"));
    }


    public static JPanel checkPanel(){
        // 分盘工具标签页
        JPanel splitPanel = new JPanel(new BorderLayout());
        JPanel leftPanel = new JPanel(new GridBagLayout());
        GridBagConstraints leftGbc = new GridBagConstraints();
        leftGbc.insets = new Insets(5, 5, 5, 5);




        leftGbc.gridx = 0;
        leftGbc.gridy = 0;
        leftGbc.anchor = GridBagConstraints.WEST;
        leftPanel.add(new JLabel("文件路径选择:"), leftGbc);
        JTextField filePathField = new JTextField(20);
        leftGbc.gridx = 1;
        leftGbc.gridwidth = 1;
        leftPanel.add(filePathField, leftGbc);

        JButton fileChooserButton = new JButton("选择目录");
        leftGbc.gridx = 2;
        leftPanel.add(fileChooserButton, leftGbc);




        leftGbc.gridx = 0;
        leftGbc.gridy = 1;
        leftGbc.anchor = GridBagConstraints.WEST;
        leftPanel.add(new JLabel("保存路径选择:"), leftGbc);
        JTextField savefilePathField = new JTextField(20);
        leftGbc.gridx = 1;
        leftGbc.gridwidth = 1;
        leftPanel.add(savefilePathField, leftGbc);

        JButton fileChooserButton2 = new JButton("选择目录");
        leftGbc.gridx = 2;
        leftPanel.add(fileChooserButton2, leftGbc);


        // 文件选择按钮的动作监听器，打开文件选择对话框
        fileChooserButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JFileChooser fileChooser = new JFileChooser();
                fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                int returnValue = fileChooser.showOpenDialog(null);
                if (returnValue == JFileChooser.APPROVE_OPTION) {
                    File selectedFile = fileChooser.getSelectedFile();
                    filePathField.setText(selectedFile.getAbsolutePath());
                }
            }
        });



        // 文件选择按钮的动作监听器，打开文件选择对话框
        fileChooserButton2.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JFileChooser fileChooser = new JFileChooser();
                fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                int returnValue = fileChooser.showOpenDialog(null);
                if (returnValue == JFileChooser.APPROVE_OPTION) {
                    File selectedFile = fileChooser.getSelectedFile();
                    savefilePathField.setText(selectedFile.getAbsolutePath());
                }
            }
        });



        leftGbc.gridx = 1;
        leftGbc.gridy = 4;
        JButton jButton = new JButton("开始检查");
        leftPanel.add(jButton, leftGbc);

        // ... 其他左边的功能选项，与前面的代码相同 ...

        // 添加到左右布局
        splitPanel.add(leftPanel, BorderLayout.WEST);
        JTextArea logTextArea = new JTextArea();
        JScrollPane logScrollPane = new JScrollPane(logTextArea);
        logScrollPane.setPreferredSize(new Dimension(200, 200));
        splitPanel.add(logScrollPane, BorderLayout.CENTER);


        jButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                // 在EDT上执行更新操作
                SwingUtilities.invokeLater(new Runnable() {
                    @Override
                    public void run() {

                        logTextArea.append(df.format(new Date())+": 检查开始。。。"+ "\n");
                        logTextArea.append(df.format(new Date())+": 检查中。。。"+ "\n");
                    }
                });
                // 启动一个异步任务

                Thread workerThread = new Thread(() -> {
                    // 执行长时间运行的业务操作

                    // 模拟耗时操作
                    try {
                        new CheckService().index(filePathField.getText(),savefilePathField.getText());
                    } catch (IOException ex) {
                        throw new RuntimeException(ex);
                    }

                    SwingUtilities.invokeLater(new Runnable() {
                        @Override
                        public void run() {
                            // 在EDT上更新UI
                            logTextArea.append(df.format(new Date())+": 检查结束。。。"+ "\n");
                        }
                    });
                });

                workerThread.start(); // 启动线程

            }

        });

        return splitPanel;
    }

    private static JPanel createIndexPanel() {
        JPanel indexPanel = new JPanel(new BorderLayout());
        JPanel leftIndexPanel = new JPanel(new GridBagLayout());
        GridBagConstraints leftIndexGbc = new GridBagConstraints();
        leftIndexGbc.insets = new Insets(5, 5, 5, 5);


        leftIndexGbc.gridx = 0;
        leftIndexGbc.gridy = 0;
        leftIndexPanel.add(new JLabel("索引模式:"));
        String[] rollmodes = {"详细索引", "简略索引"};
        JComboBox<String> rollmodeComboBox = new JComboBox<>(rollmodes);
        leftIndexGbc.gridx = 1;
        leftIndexGbc.gridwidth = 1;
        leftIndexPanel.add(rollmodeComboBox);

        leftIndexGbc.gridx = 0;
        leftIndexGbc.gridy = 1;
        leftIndexGbc.anchor = GridBagConstraints.WEST;
        leftIndexPanel.add(new JLabel("文件路径选择:"), leftIndexGbc);
        JTextField filePathField = new JTextField(20);
        leftIndexGbc.gridx = 1;
        leftIndexGbc.gridwidth = 1;
        leftIndexPanel.add(filePathField, leftIndexGbc);

        JButton fileChooserButton = new JButton("选择目录");
        leftIndexGbc.gridx = 2;
        leftIndexPanel.add(fileChooserButton, leftIndexGbc);

        // 文件选择按钮的动作监听器，打开文件选择对话框
        fileChooserButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                JFileChooser fileChooser = new JFileChooser();
                fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                int returnValue = fileChooser.showOpenDialog(null);
                if (returnValue == JFileChooser.APPROVE_OPTION) {
                    File selectedFile = fileChooser.getSelectedFile();
                    filePathField.setText(selectedFile.getAbsolutePath());
                }
            }
        });

//        leftIndexGbc.gridx = 0;
//        leftIndexGbc.gridy = 1;
//        leftIndexGbc.anchor = GridBagConstraints.WEST;
//        leftIndexPanel.add(new JLabel("图片dpi:"), leftIndexGbc);
//        leftIndexGbc.gridx = 1;
//        JTextField dpiField = new JTextField(5);
//        leftIndexPanel.add(dpiField, leftIndexGbc);

        // ... 其他标签左对齐，与前面的代码相同 ...

        leftIndexGbc.gridx = 0;
        leftIndexGbc.gridy = 3;
        leftIndexGbc.gridwidth = 2;
        leftIndexGbc.anchor = GridBagConstraints.CENTER;
        JButton jButton = new JButton("开始生成索引");
        leftIndexPanel.add(jButton, leftIndexGbc);


        JTextArea indexLogTextArea = new JTextArea();
        JScrollPane indexLogScrollPane = new JScrollPane(indexLogTextArea);
        indexLogScrollPane.setPreferredSize(new Dimension(200, 200));
        JPanel rightIndexPanel = new JPanel(new BorderLayout());
        rightIndexPanel.add(indexLogScrollPane, BorderLayout.CENTER);

        indexPanel.add(leftIndexPanel, BorderLayout.WEST);
        indexPanel.add(rightIndexPanel, BorderLayout.CENTER);



        jButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                DateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                // 在EDT上执行更新操作
                SwingUtilities.invokeLater(new Runnable() {
                    @Override
                    public void run() {

                        indexLogTextArea.append(df.format(new Date())+": 索引开始。。。"+ "\n");
                        indexLogTextArea.append(df.format(new Date())+": 索引中。。。"+ "\n");
                    }
                });
                // 启动一个异步任务

                Thread workerThread = new Thread(() -> {
                    // 执行长时间运行的业务操作

                    // 模拟耗时操作
                    try {
                        new SuoyinService().index(filePathField.getText(),rollmodeComboBox.getSelectedItem().toString());
                    } catch (IOException ex) {
                        throw new RuntimeException(ex);
                    }

                    SwingUtilities.invokeLater(new Runnable() {
                        @Override
                        public void run() {
                            // 在EDT上更新UI
                            indexLogTextArea.append(df.format(new Date())+": 索引结束。。。"+ "\n");
                        }
                    });
                });

                workerThread.start(); // 启动线程

            }

        });


        return indexPanel;
    }
}
